const uint MAX_INT = 4294967295;

int fontFace;
uint uiIndex = MAX_INT;
uint uiTextIndex = MAX_INT;
uint arrlength = 0;
bool isMP3UI = false;

void Render() {
    //PrintLabelsAll('m'); // GetPlayer().DisplaySpeed + ''

    MwFastBuffer<CSceneMobil@> assets = GetAssetsIngame();
    GetUIIndex(assets);

    //print(uiIndex + ' | ' + uiTextIndex);
    if (!Setting_Enable || GetApp().InputPort.InputsMode != 0) return;
    vec3[] enviSettings = GetEnviTextSettings();
    string speed = AdjustString(Math::Floor(GetVelocity().Length() * 3.6) + '');


    if (uiIndex != MAX_INT && !IsSpeedVisible(assets)) {
        HideUISpeed(assets, Setting_Enable);
        SpeedUI(speed);
    }


    if (IsCam3Enabled() || !Setting_Enable3D) return;
    float scaler = enviSettings[3].x;
    bool enableBg = enviSettings[3].y == 1;

    if (Camera::IsBehind(ProjectVerticeSpace(VehicleState::GetVis(GetApp().GameScene, VehicleState::GetViewingPlayer()).AsyncState, enviSettings[0]))) return;

    if (enableBg) DrawSquare((vec3(AlineXAxis(enviSettings[0].x, speed) - (0.85 * scaler), enviSettings[0].y - (0.05 * scaler), enviSettings[0].z + 0.001)), vec3((1.185 * scaler), (0.795 * scaler), 0), enviSettings[2]);
    Numbers::DrawString(speed, vec3(AlineXAxis(enviSettings[0].x, speed), enviSettings[0].y, enviSettings[0].z), enviSettings[1], scaler);
}

void Main()
{
#if TMNEXT
    warn('This plugin does not support TM2020.');
    return;
#elif TURBO
    warn('This plugin does not support Turbo.');
    return;
#endif

    fontFace = nvg::LoadFont("DroidSans-Bold.ttf");
}

void RenderMenu() {
    if(UI::MenuItem("\\$08f" + Icons::PlayCircleO + "\\$z Enable Real Speed", "", Setting_Enable)) {
		Setting_Enable = !Setting_Enable;
	}
}

bool IsSpeedVisible(MwFastBuffer<CSceneMobil@> assets) {
    CControlLabel@ label = cast<CControlLabel@>(assets[uiTextIndex].Item.SceneMobil);
    if (label !is null) return label.IsHiddenInternal;
    CControlEntry@ entry = cast<CControlEntry@>(assets[uiTextIndex].Item.SceneMobil);
    if (entry !is null) return entry.IsHiddenInternal;

    return false;
}

void HideUISpeed(MwFastBuffer<CSceneMobil@> assets, bool hide) {
    CControlLabel@ label = cast<CControlLabel@>(assets[uiIndex].Item.SceneMobil);
    if (label !is null) {hide ? label.Hide() : label.Show(); return;}

    CControlEntry@ entry = cast<CControlEntry@>(assets[uiIndex].Item.SceneMobil);
    if (entry !is null) {hide ? entry.Hide() : entry.Show(); return;}
}

CGameManiaPlanetScriptAPI@ GetManiaplanetAPI() {
    CGameManiaPlanet@ mp = cast<CGameManiaPlanet>(GetApp());
    return cast<CGameManiaPlanetScriptAPI>(mp.ManiaPlanetScriptAPI);
}

vec3[] GetEnviTextSettings() {
    string openEnvi = GetApp().RootMap.MapInfo.CollectionName;
    if (openEnvi == "Canyon") return {Setting_CanyonPos, Setting_TextColourCanyon, Setting_BgColourCanyon, vec3(Setting_CanyonSize, Setting_EnableBgCanyon ? 1 : 0, 0)};
    else if (openEnvi == "Valley") return {Setting_ValleyPos, Setting_TextColourValley, Setting_BgColourValley, vec3(Setting_ValleySize, Setting_EnableBgValley ? 1 : 0, 0)};
    else if (openEnvi == "Lagoon") return {Setting_LagoonPos, Setting_TextColourLagoon, Setting_BgColourLagoon, vec3(Setting_LagoonSize, Setting_EnableBgLagoon ? 1 : 0, 0)};
    else return {Setting_StadiumPos, Setting_TextColourStadium, Setting_BgColourStadium, vec3(Setting_StadiumSize, Setting_EnableBgStadium ? 1 : 0, 0)};
}

CTrackManiaPlayer@ GetPlayer() {
    if (GetApp().CurrentPlayground is null) {return null;}
    if (GetApp().CurrentPlayground.GameTerminals.Length == 0) {return null;}
    auto gameTerminal = cast<CTrackManiaGameTerminal@>(GetApp().CurrentPlayground.GameTerminals[0]);
    return cast<CTrackManiaPlayer@>(gameTerminal.ControlledPlayer);
}

float AlineXAxis(float center, const string &in speed) {
    if (speed.Length > 0) return (speed.Length * 0.03) + center;
    else return center;
}

string AdjustString(const string &in speed) {
    if (speed.Length == 1) return '00' + speed;
    else if (speed.Length == 2) return '0' + speed;
    else return speed;
}

bool IsCam3Enabled() {
    if (GetApp().Viewport.Cameras.Length < 2) return false;
    return GetApp().Viewport.Cameras[1].DofFocusZ == 10.000;
}

vec3 GetVelocity() {
    return VehicleState::GetVis(GetApp().GameScene, VehicleState::GetViewingPlayer()).AsyncState.WorldVel;
}

void SpeedUI(const string &in text) {
    bool isOnline = GetManiaplanetAPI().CurrentServerLogin != '';

    uint textSize = isMP3UI ? 40 : isOnline ? 50 : 70;
    vec2 position = isMP3UI ? vec2(1465, 712.5) : isOnline ? vec2(1390, 655) : vec2(1325, 615);

    nvg::FontFace(fontFace);
    nvg::FontSize(UITextSizeScaler(textSize));
    nvg::Scale(vec2(1.25, 1.5));
    nvg::Text(UITextPosScaler(position), text);
    nvg::Reset();
}

vec2 UITextPosScaler(vec2 pos) {
    vec2 scaler = vec2(Draw::GetWidth() / 1920.0, Draw::GetHeight() / 1080.0);
    return pos * scaler;
}

int UITextSizeScaler(int size) {
    return int(size * (Draw::GetWidth() / 1920.0));
}

void PrintArr(uint[] arr) {
    string concat = '';
    for (uint i = 0; i < arr.Length; i++) concat += ' | ' + arr[i];
    print(concat);
}

void PrintLabelsAll(const string &in search = '', bool isRegex = false) {
    auto assets = GetAssetsIngame();
    if (arrlength == assets.Length) return;

    for (uint i = 0; i < assets.Length; i++) {
        CControlLabel@ label = cast<CControlLabel@>(assets[i].Item.SceneMobil);
        CControlEntry@ entry = cast<CControlEntry@>(assets[i].Item.SceneMobil);
        if (label !is null) {
            if (search != '') {
                if (isRegex) {if (Regex::Contains(label.Label, search)) print(label.Label + ' | ' + i);}
                else {if (label.Label == search) print(label.Label + ' | ' + i);}
            } else print(label.Label + ' | ' + i);
        } 
        else if (entry !is null) {
            if (search != '') {
                if (isRegex) {if (Regex::Contains(entry.String, search)) print(entry.String + ' | ' + i);}
                else {if (entry.String == search) print(entry.String + ' | ' + i);}
            } else print(entry.String + ' | ' + i);
        }

        
    }
}

void GetUIIndex(MwFastBuffer<CSceneMobil@> assets) {
    if (arrlength == assets.Length || GetPlayer() is null) return;

    for (uint i = assets.Length - 1; i > 0; i--) {
        CControlLabel@ label = cast<CControlLabel@>(assets[i].Item.SceneMobil);
        if (label !is null) {
            if (Regex::Contains(label.Label, 'KM') || label.Label == 'm') {
                uiTextIndex = i;

                for (uint j = i - 10; j < (i + 10); j++) {
                    CControlEntry@ entry = cast<CControlEntry@>(assets[j].Item.SceneMobil);
                    @label = cast<CControlLabel@>(assets[j].Item.SceneMobil);
                    isMP3UI = entry !is null;

                    if (label !is null && label.Label == (GetPlayer().DisplaySpeed + '') || entry !is null && entry.String == (GetPlayer().DisplaySpeed + '')) {
                        uiIndex = j;
                        arrlength = assets.Length;
                        return;
                    }
                }
            }
        }
    }

    arrlength = assets.Length;
    uiIndex = MAX_INT;
}

bool IsOnline() {
    return GetManiaplanetAPI().CurrentServerLogin != '';
}


MwFastBuffer<CSceneMobil@> GetAssetsIngame() {
    for (uint i = 0; i < GetApp().Viewport.Overlays.Length; i++) {
        if (GetAssetsLength(i) != MAX_INT && GetVisibleAssetsLength(i) != 0 && GetAssetsLength(i) >= 100) {return cast<CSceneSector@>(GetApp().Viewport.Overlays[i].UserData).Scene.Mobils;
    }}
    return MwFastBuffer<CSceneMobil@>();
}

uint GetAssetsLength(uint index) {
    if (GetApp().Viewport.Overlays.Length < (index + 1) || GetApp().Viewport.Overlays[index].UserData is null) return MAX_INT;
    return cast<CSceneSector@>(GetApp().Viewport.Overlays[index].UserData).Scene.Mobils.Length;
}

uint GetVisibleAssetsLength(uint index) {
    if (GetApp().Viewport.Overlays.Length < (index + 1)) return 0;
    return cast<CHmsZoneOverlay@>(GetApp().Viewport.Overlays[index]).CorpusVisibles.Length;
}